#if _MSC_VER > 1000
#pragma once
#endif

#ifndef _CCSVFile_H__
#define _CCSVFile_H__
#include <stdio.h>

#define CCSVFILE_is_sjis1(c) (((((unsigned char)(c))>=0x81)&&(((unsigned char)(c))<=0x9F))||((((unsigned char)(c))>=0xE0)&&(((unsigned char)(c))<=0xFC)))
#define CCSVFILE_is_sjis2(c) ((((unsigned char)(c))!=0x7F)&&(((unsigned char)(c))>=0x40)&&(((unsigned char)(c))<=0xFC))

#define CCSVFILE_NOBUFFER() (rowsize == 0L && colsize == 0L && datumsize == 0L && buffer == (char***)NULL)

class CCSVFile
{
	FILE			*fp;

	unsigned long	rowsize;	// s
	unsigned long	colsize;	// 
	unsigned long	datumsize;	// f[^̍ő咷

	char			***buffer;

	bool			CheckCSV();
	bool			ReadData();

public:
	CCSVFile();
	~CCSVFile();

	// t@CCSVf[^ǂݏo
	bool			LoadBuffer(char *filename);
	// ǂݏof[^
	void			ReleaseBuffer();

/*	bool			WriteBuffer(char *filename, double **data, unsigned long rows, unsigned long cols);
	bool			WriteBuffer(char *filename, long **data, unsigned long rows, unsigned long cols);
	bool			WriteBuffer(char *filename, int **data, unsigned long rows, unsigned long cols);*/
	// obt@̓et@CCSVf[^Ƃď
	bool			WriteBuffer(char *filename);
	// wf[^t@CCSVf[^Ƃď
	bool			WriteBuffer(char *filename, char ***data, unsigned long rows, unsigned long cols, unsigned long datumlen);

	// evCx[gϐǂݏo
	char			***GetCSVBuffer(){ return buffer; };
	char			**GetCSVBuffer(unsigned long row){ return(row < rowsize)?buffer[row]:(char**)NULL; };
	char			*GetCSVBuffer(unsigned long row, unsigned long col){ return(row < rowsize && col < colsize)?buffer[row][col]:(char*)NULL; };
	unsigned long	GetRowSize(){ return rowsize; };
	unsigned long	GetColSize(){ return colsize; };
	unsigned long	GetDatumSize(){ return datumsize; };
};


#endif //_CCSVFile_H__